// MP3Stream_acm.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "MP3Stream_acm.h"
#include <mmsystem.h>
#include <dsound.h>
#include "DSQuickLib.h"
#include <stdio.h>

#include <sys/types.h>
#include <sys/stat.h>	// stat ֐g׃CN[h
#include <crtdbg.h>
#include <TCHAR.h>
#include <vfw.h>
#include <mmreg.h>
#include <msacm.h>
#include "MP3StreamSound.h"

#pragma comment (lib, "msacm32.lib")
#pragma comment (lib, "winmm.lib")
#pragma comment (lib, "vfw32.lib")


LRESULT CALLBACK WndProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam);
LRESULT CALLBACK IOProc(LPMMIOINFO lpMMIOInfo, UINT uMessage, LPARAM lParam1, LPARAM lParam2);

//	O[oϐ
CDSoundEnv	*g_pDSoundEnv = NULL;
static char * g_lpData = NULL;
static long	g_cfileSize;
CRITICAL_SECTION	g_csSema;
CMP3StreamSound	*g_pMP3StreamSound = NULL;

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
	_CrtSetDbgFlag ( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF );

	WNDCLASSEX wcex;
    wcex.cbSize = sizeof(WNDCLASSEX); 
    wcex.style            = CS_HREDRAW | CS_VREDRAW;
    wcex.lpfnWndProc    = (WNDPROC)WndProc;
    wcex.cbClsExtra        = 0;
    wcex.cbWndExtra        = 0;
    wcex.hInstance        = hInstance;
    wcex.hIcon            = LoadIcon(NULL, MAKEINTRESOURCE(IDI_APPLICATION));
    wcex.hCursor        = LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
    wcex.hbrBackground    = (HBRUSH)(COLOR_WINDOW+1);
    wcex.lpszMenuName    = NULL;
    wcex.lpszClassName    = _T("mp3 realtime audio stream");
    wcex.hIconSm        = LoadIcon(NULL, IDI_APPLICATION);
    RegisterClassEx(&wcex);

	InitializeCriticalSection(&g_csSema);
    HWND hWnd;
    hWnd = CreateWindowEx(WS_EX_OVERLAPPEDWINDOW,wcex.lpszClassName,_T("mp3 realtime audio stream"),
                WS_VISIBLE|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX|WS_MAXIMIZEBOX,
                CW_USEDEFAULT,0,640,480,NULL,NULL,hInstance,NULL);
    if( !hWnd )
        return FALSE;

    RECT    bounds,client;
    GetWindowRect(hWnd,&bounds);
    GetClientRect(hWnd,&client);
    MoveWindow(hWnd,bounds.left,bounds.top,
        640 * 2 - client.right,
        480 * 2 - client.bottom,
        false );

    ShowWindow( hWnd, nCmdShow );
    UpdateWindow( hWnd );

	g_pDSoundEnv = new CDSoundEnv(2,44100,16);
	if (g_pDSoundEnv){
		if (SUCCEEDED(g_pDSoundEnv->Initialize(hWnd,DSSCL_PRIORITY))){
			struct	_stat	status;
			if (0 == _tstat(_T("Sample.mp3"),&status)){
				g_cfileSize = status.st_size;
				g_lpData = new char[g_cfileSize];
				FILE	*fp = fopen(_T("Sample.mp3"),_T("rb"));
				if (fp != NULL){
					fread(g_lpData,g_cfileSize,1,fp);
					fclose(fp);
				}
				//	mci:JX^IOProc ̃CXg[
				mmioInstallIOProc(mmioFOURCC('M', 'M', 'S', ' '), (LPMMIOPROC)IOProc,
									MMIO_INSTALLPROC | MMIO_GLOBALPROC);
				g_pMP3StreamSound = new CMP3StreamSound(g_pDSoundEnv,_T("test.MMS+"));
				g_pMP3StreamSound->Prepare();
				g_pMP3StreamSound->Rewind();
				g_pMP3StreamSound->Play();
			}
		}
	}
	BOOL	bFlag1 = false;
	BOOL	bFlag2 = false;
	BOOL	bFlag3 = false;
	BOOL	bFlag4 = false;
	BOOL	bPlaying = true;
	MSG        msg;
    while(true){
        if(PeekMessage(&msg, 0, 0, 0, PM_REMOVE)){
            if(msg.message == WM_QUIT)
                break;
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        }else{
			g_pDSoundEnv->PollStatus();

			//	Đ̃Rg[

			//	L[ 1
			if (::GetAsyncKeyState('1')){
				if (!bFlag1 && g_pMP3StreamSound){
					bPlaying = true;
					g_pMP3StreamSound->Play();
				}
				bFlag1 = true;
			}else{
				bFlag1 = false;
			}

			//	L[ 2
			if (::GetAsyncKeyState('2')){
				if (!bFlag2 && g_pMP3StreamSound){
					g_pMP3StreamSound->Pause();
					bPlaying = false;
				}
				bFlag2 = true;
			}else{
				bFlag2 = false;
			}

			//	L[ 3
			if (::GetAsyncKeyState('3')){
				if (!bFlag3 && g_pMP3StreamSound){
					g_pMP3StreamSound->FadeOut(180);
					bPlaying = false;
				}
				bFlag3 = true;
			}else{
				bFlag3 = false;
	
			}

			//	L[ 4
			if (::GetAsyncKeyState('4')){
				if (!bFlag4 && g_pMP3StreamSound){
					g_pMP3StreamSound->Play(0,0,0,-1,0,60);
					bPlaying = true;
				}
				bFlag4 = true;
			}else{
				bFlag4 = false;
	
			}

			if (!g_pMP3StreamSound->IsPlaying() && bPlaying){
				Sleep(100);
				g_pMP3StreamSound->Rewind();
				g_pMP3StreamSound->Play();
			}
        }
    }
	if (g_pMP3StreamSound)
		delete	g_pMP3StreamSound;
	if (g_pDSoundEnv)
		delete	g_pDSoundEnv;


	EnterCriticalSection(&g_csSema);
	if (g_lpData != NULL){
		mmioInstallIOProc(mmioFOURCC('M', 'M', 'S', ' '), NULL,MMIO_REMOVEPROC);
		delete	g_lpData;
		g_lpData = NULL;
	}
	LeaveCriticalSection(&g_csSema);
    return (int)msg.wParam;
}

//
//	֐FWndProc
//	FEChEɓnꂽCxg̃nh
//
LRESULT CALLBACK WndProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{

    switch (message){
		case WM_PAINT:
			{
				HDC	hDC;
				PAINTSTRUCT	paintStruct;
                hDC = BeginPaint(hWnd,&paintStruct);
				RECT	rc;
				GetClientRect(hWnd,&rc);
				DrawText(hDC,_T("̃AvP[V̓I[fBIĐ̂ݍs܂B"),-1,&rc,DT_NOCLIP);
				rc.top += 30;
				DrawText(hDC,_T("f͍Đ܂B"),-1,&rc,DT_NOCLIP);
				rc.top += 30;
				rc.left += 40;
				DrawText(hDC,_T("key\'1\' -- Play MP3 Stream"),-1,&rc,DT_NOCLIP);
				rc.top += 20;
				DrawText(hDC,_T("key\'2\' -- Pause MP3 Stream"),-1,&rc,DT_NOCLIP);
				rc.top += 20;
				DrawText(hDC,_T("key\'3\' -- Fadeout MP3 Stream"),-1,&rc,DT_NOCLIP);
				rc.top += 20;
				DrawText(hDC,_T("key\'4\' -- Fadein MP3 Stream"),-1,&rc,DT_NOCLIP);

                ::EndPaint(hWnd,&paintStruct);
            }
            return DefWindowProc(hWnd, message, wParam, lParam);
        case WM_DESTROY:
            PostQuitMessage(0);
            break;
        default:
            return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return    0;
}


//
//	mmio: IOProc
//
LRESULT CALLBACK IOProc(LPMMIOINFO lpMMIOInfo, UINT uMessage, LPARAM
lParam1, LPARAM lParam2)
{
  static BOOL alreadyOpened = FALSE;

  switch (uMessage) {
  case MMIOM_OPEN:
      if (alreadyOpened)
          return 0;
      alreadyOpened = TRUE;

      lpMMIOInfo->lDiskOffset = 0;
      return 0;

   case MMIOM_CLOSE:
       return 0;

   case MMIOM_READ:{
			LPARAM	dataRead = 0;
	   		EnterCriticalSection(&g_csSema);
			if (g_lpData != NULL){
				dataRead = lParam2;
				memcpy((void *)lParam1, g_lpData+lpMMIOInfo->lDiskOffset, lParam2);
				lpMMIOInfo->lDiskOffset += lParam2;
				dataRead = lParam2;
			}
			LeaveCriticalSection(&g_csSema);
			return (dataRead);
		}
   case MMIOM_SEEK:
       switch (lParam2) {
       case SEEK_SET:
           lpMMIOInfo->lDiskOffset = lParam1;
           break;

       case SEEK_CUR:
           lpMMIOInfo->lDiskOffset += lParam1;
           break;

       case SEEK_END:
           lpMMIOInfo->lDiskOffset = g_cfileSize - lParam1;
           break;
       }
       return lpMMIOInfo->lDiskOffset;

   default:
       return -1;
   }
}